
import javax.microedition.lcdui.*;

/**Clase gameCanvas en donde se despliega el juego*/
public class gameCanvas extends Canvas implements Runnable
{

    private int winner;
    /**variable que indica que ficha tiene el jugador*/
    public int player;

    /**indica cual es tu turno de jugar*/
    public boolean YourTurn=true;
    /**indica cuando el juego ha terminado*/
    public boolean gameEnd=false;

    private static final int circle = 1;
    private static final int cross = -1;
    private static final int nowinner = 2;

    private int width = getWidth();//Screen width
    private int height = getHeight();//Screen Height

    private int slotWidth;
    private int slotHeight;

    private int cursorX=0, cursorY=0;

    private TicTacToe game;

    /**variable que guarda que fichas existen en las distintas casillas del tablero*/
    public int[][] slots;

    /**hilo que corre para recibir coordenadas*/
    public Thread thread;

    /**variable que permite correr al hilo de recepcion de coordenadas*/
    public boolean RunThread=false;
    /**indica si es servidor, si no, es cliente*/
    public boolean IsServer;
    private ClientServer clientServerObj;

    private boolean nowput;

    private int Rows;
    private int Cols;

    /**Constructor del gameCanvas
	@param X cantidad de casillas horizontales.
	@param Y cantidad de casillas verticales.*/
    gameCanvas(int X, int Y)
    {
        Cols=X;//numero de columnas
        Rows=Y;//numero de filas

        slotWidth = (width-(X-1))/X;//obtiene el ancho de cada casilla
        slotHeight = (height-(Y-1))/Y;//otiene el alto de cada casilla

        slots = new int[X][Y];

        for(int row =0;row<Y;row++)//llena el tablero con 0 fichas
        {
            for(int col =0;col<X;col++)
            {
                slots[row][col]=0;
            }
        }

    }

    /**Entrega la instancia del juego actual
	@param game1 juego actual a ser instanciado.*/
    void setInstance(TicTacToe game1){
        game=game1;
    }

    /**mueve el cusror hacia abajo*/
    void MoveDOWN() {
        if(cursorY<(Cols-1))cursorY++;
    }
    /**mueve el cusror hacia la izquierda*/
    void MoveLEFT() {
        if(cursorX>0)cursorX--;
    }
    /**mueve el cusror hacia la derecha*/
    void MoveRIGHT() {
        if(cursorX<(Rows-1))cursorX++;
    }
    /**mueve el cusror hacia arriba*/
    void MoveUP() {
        if(cursorY>0)cursorY--;
    }
    /**selecciona la ficha en la casilla y la deja en otra casilla*/
    void SELECT() {
        if(nowput==false)
        {
            slots[cursorX][cursorY]=0;//saca la ficha de la casilla actual
            nowput=true;
        }
        else
        {
            slots[cursorX][cursorY]=player;//pone la ficha en la nueva casilla
            clientServerObj.SendInt(cursorX);
            clientServerObj.SendInt(cursorY);
            nowput=false;
            YourTurn=false;
        }
        
    }
    /**pone la ficha en la casilla*/
    void PUT() {
        slots[cursorX][cursorY]=player;
        clientServerObj.SendInt(cursorX);
        clientServerObj.SendInt(cursorY);
        YourTurn=false;
    }
    /**va a la casilla x,y
    @param x coordenada x de la casilla.
	@param y coordenada y de la casilla.*/
    void goTO(int x, int y) {
        cursorX=x;
        cursorY=y;
    }

    /**Metodo que pinta el canvas
    @param gr del tipo Graphics, para poder dibujar con metodos de esta libreria*/
	public void paint(Graphics gr)
    {

        //llena el fondo
        gr.setColor(255,255,255);
        gr.fillRect(0, 0, width, height);

        //setea el color de las lineas
        gr.setColor(0, 0, 0);

        //dibuja las lineas verticales
        for(int i=0; i<Cols-1; i++)
        {
            gr.drawLine((i+1)*slotWidth, 0, (i+1)*slotWidth, height);
        }

        //dibuja las lineas horizontales
         for(int i=0; i<Cols-1; i++)
        {
            gr.drawLine(0, (i+1)*slotHeight, width, (i+1)*slotHeight);
        }

        //dibuja las casillas que estan ocupadas por alguna ficha
        for(int row =0;row<Rows;row++)
        {
            for(int col =0;col<Cols;col++)
            {
                for(int i=0;i<game.totalCheckers;i++)
                {
                    switch(slots[col][row])
                    {
                        case -1:
                        //dibuja una X
                        gr.setColor(0, 200, 0);
                        gr.drawLine(slotWidth*col, slotHeight*row, slotWidth*col + slotWidth, slotHeight*row + slotHeight);
                        gr.drawLine(slotWidth*col + slotWidth, slotHeight*row, slotWidth*col, slotHeight*row + slotHeight);
                        break;
                        case 1:
                        //dibuja un O
                        gr.setColor(200, 0, 0);
                        gr.drawArc(slotWidth*col, slotHeight*row, slotWidth, slotHeight, 0, 360);
                        break;
                        default:
                        break;
                    }
                }
            }
        }

        //dibuja el cursor
        gr.setColor(255, 0, 0);
        gr.drawRect(slotWidth*cursorX+2, slotHeight*cursorY+2, slotWidth-4, slotHeight-4);

        winner=game.CheckWinner();//revisa quien gana
        //anuncia al ganador
        if(winner == player)
        {
            gr.setColor(0, 255, 0);
            gr.drawString("You Win", width/2, height/2, Graphics.BASELINE | Graphics.HCENTER);
            gameEnd=true;
        }
        else if(winner == -player)
        {
            gr.setColor(255, 0, 0);
            gr.drawString("You Lose", width/2, height/2, Graphics.BASELINE | Graphics.HCENTER);
            gameEnd=true;
        }
        else if(winner == nowinner)
        {
            gr.setColor(0, 0, 255);
            gr.drawString("No winner", width/2, height/2, Graphics.BASELINE | Graphics.HCENTER);
            gameEnd=true;
        }

	}



    /**Mmetodo run que se usa para dejar corriendo el hilo de recepcion*/
    public void run()
    {
        if(clientServerObj==null)
        {
            clientServerObj=new ClientServer(IsServer);//crea el objeto clienteservidor
        }
        while(RunThread)//espera a poder empezar a correr el hilo
        {
            try
            {
                //recive las coordenadas
                int x = clientServerObj.RecieveInt();
                int y = clientServerObj.RecieveInt();

                if(!IsServer) slots[x][y]=cross;
                else slots[x][y]=circle;

                YourTurn=true;//ahora es tu turno para jugar
                repaint();
            }
            catch(Exception ex)
            {
                //System.out.println(ex.getMessage());
            }

         }
    }

}
